<template>
  <div>
    <h2>Vue.js WebSocket Tutorial</h2>
    <button @click="sendMessage('helloww')">Send Message</button>
    <h4>Response: {{ serverMessage }}</h4>
  </div>
</template>

<script>
export default {
  name: "Home",
  data() {
    return {
      connection: null,
      serverMessage: "",
      intervalId: null,
      wsUrl: "ws://127.0.0.1:3001"
    };
  },
  methods: {
    sendMessage: function(message) {
      // console.log(this.connection);
      this.connection.send(message);
    }
  },
  created() {
    console.log("Starting connection to WebSocket Server");
    this.connection = new WebSocket(this.wsUrl);

    this.connection.onopen = function(event) {
      // console.log(event);
      console.log("Successfully connected to the websocket server...", event);
    };

    this.connection.onclose = event => {
      console.log("Connection Closed", event);

      if (event.wasClean === false) {
        // eslint-disable-next-line no-unused-vars
        let intervalId = setTimeout(() => {
          if (this.connection.readyState === 1) {
            clearInterval(intervalId);
            return;
          }

          console.log("Reconnecting to WebSocket Server");
          this.connection = new WebSocket(this.wsUrl);
        }, 3000);
      }
    };

    this.connection.onerror = function(error) {
      console.log("Error connecting:", error);
    };
  },
  watch: {
    connection(newValue) {
      let self = this;
      console.log("Connection Watcher:", newValue);

      newValue.onmessage = function(event) {
        console.log("Response from server...:", event);
        self.serverMessage = event.data;
      };

      newValue.onerror = function(event) {
        console.log("ERROR:", event);
      };
    }
  }
};
</script>
